stages:
  - build
  - deploy

variables:
  KUBECONFIG: /etc/deploy/config

build:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  stage: build
  before_script:
    - export TAG=$(cat tag)
  script: |
    echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > \
      /kaniko/.docker/config.json
    /kaniko/executor \
      --context $CI_PROJECT_DIR \
      --dockerfile $CI_PROJECT_DIR/Dockerfile \
      --destination $CI_REGISTRY_IMAGE:$TAG
  tags:
    - ${RUNNER_TAG}

deploy-staging:
  image: dtzar/helm-kubectl:3.0.0
  stage: deploy
  before_script:
    - mkdir /etc/deploy
    - echo ${KUBECONFIG_BASE64} | base64 -d > ${KUBECONFIG}
    - kubectl config use-context ${KUBECONFIG_CONTEXT}
    - helm repo add $helmRepo$ $museum$
    - helm repo update
  script:
    - export DEPLOYS=$(helm list -n ${STAGING_NAMESPACE} | grep $backNameVersion$ | wc -l)
    - if [ ${DEPLOYS} -eq 0 ]; then
      helm install $backNameVersion$ $helmRepo$/$chart$ -n ${STAGING_NAMESPACE} -f values.yaml --set "imagePullSecrets={${IMAGE_PULL_SECRET}}";
      else
      helm upgrade $backNameVersion$ $helmRepo$/$chart$ -n ${STAGING_NAMESPACE} -f values.yaml --set "imagePullSecrets={${IMAGE_PULL_SECRET}}";
      fi
  tags:
    - ${RUNNER_TAG}

deploy-production:
  image: dtzar/helm-kubectl:3.0.0
  stage: deploy
  when: manual
  before_script:
    - mkdir /etc/deploy
    - echo ${KUBECONFIG_BASE64} | base64 -d > ${KUBECONFIG}
    - kubectl config use-context ${KUBECONFIG_CONTEXT}
    - helm repo add $helmRepo$ $museum$
    - helm repo update
  script:
    - export DEPLOYS=$(helm list -n ${PRODUCTION_NAMESPACE} | grep $backNameVersion$ | wc -l)
    - if [ ${DEPLOYS} -eq 0 ]; then
      helm install $backNameVersion$ $helmRepo$/$chart$ -n ${PRODUCTION_NAMESPACE} -f values.yaml --set "imagePullSecrets={${IMAGE_PULL_SECRET}}";
      else
      helm upgrade $backNameVersion$ $helmRepo$/$chart$ -n ${PRODUCTION_NAMESPACE} -f values.yaml --set "imagePullSecrets={${IMAGE_PULL_SECRET}}";
      fi
  tags:
    - ${RUNNER_TAG}
